/*
*******************************************************************************
* $Header: $
*
*  Copyright (c) 2000-2018 VIVOTEK Inc. All rights reserved.
*
*  +-----------------------------------------------------------------+
*  | THIS SOFTWARE IS FURNISHED UNDER A LICENSE AND MAY ONLY BE USED |
*  | AND COPIED IN ACCORDANCE WITH THE TERMS AND CONDITIONS OF SUCH  |
*  | A LICENSE AND WITH THE INCLUSION OF THE THIS COPY RIGHT NOTICE. |
*  | THIS SOFTWARE OR ANY OTHER COPIES OF THIS SOFTWARE MAY NOT BE   |
*  | PROVIDED OR OTHERWISE MADE AVAILABLE TO ANY OTHER PERSON. THE   |
*  | OWNERSHIP AND TITLE OF THIS SOFTWARE IS NOT TRANSFERRED.        |
*  |                                                                 |
*  | THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT   |
*  | ANY PRIOR NOTICE AND SHOULD NOT BE CONSTRUED AS A COMMITMENT BY |
*  | VIVOTEK INC.                                                    |
*  +-----------------------------------------------------------------+
*
* $History: $
*/

/*!
*******************************************************************************
* Copyright 2000-2018 VIVOTEK, Inc. All rights reserved.
*
* \file
* icr_locals.h
*
* \brief
* The header file contains linux version dependence kernel api.
*
*
* \date
* 2018/04/09
*
* \author
* Tim Kuo <Tim.Kuo@vivotek.com>
*
*******************************************************************************
*/
#include <linux/device.h>
#include "typedef.h"

#define _DEBUG
#ifdef _DEBUG
#define DBG(x...)	printk(x)
#else
#define DBG(x...)
#endif

#define ICR_MAJOR_DEFAULT			248
#define ICR_CTRL_LOGIC_DEFAULT		0
#define ICR_VFS_INTERFACE			"ICR"
#define ICR_SYSLOG_ID				"[VivotekICR]:"


#define DAY_MODE			0
#define NIGHT_MODE			1

#define ENABLE				1
#define DISABLE				0

#define ICR_DEV_OPENED		1
#define ICR_DEV_CLOSEED		0

#define IR_EXCITATION_TIME	100 //ms
#define IR_CUT_HW_DELAY		100 //ms

typedef struct icr_ctrl_pin
{
	unsigned long ulChannel;
	unsigned long ulPort;
} TICRCtrlPin;

typedef struct icr_local_info
{
	BOOL bOpenStatus;
	struct mutex mutex_lock;
#define CTRL_PIN			0
#define ENABLE_PIN			1
#define CTRL_PIN_NUMBER		2
	TICRCtrlPin tCtrlPin[CTRL_PIN_NUMBER];
	BOOL bCtrlLogic;
} TICRLocalInfo;

int Set_SPI_CS_PIN(unsigned long ulSpics);
void pt5111_init_cfg(void);
void ICR_enable(void);
void ICR_disable(void);


extern void hi_ssp_enable(void);
extern void hi_ssp_disable(void);
extern int hi_ssp_sel_cs(unsigned int uiSpics);
extern void hi_ssp_set_frameform(unsigned char framemode,unsigned char spo,unsigned char sph,unsigned char datawidth);
extern void hi_ssp_set_serialclock(unsigned char scr,unsigned char cpsdvsr);
extern void hi_ssp_alt_mode_set(int enable);
extern void hi_ssp_set_spi4_reverse(void);
extern void spi_enable(void);
extern void spi_disable(void);
extern void spi_write_a16byte(unsigned short spi_dat, unsigned int spi_cs);


